/*
 * $Id: ModelUpdateManager.java,v 1.9 2000/10/06 15:53:35 lblair Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */


package com.sun.j2ee.blueprints.petstore.control.ejb;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Map;

import javax.ejb.EJBException;

import com.sun.j2ee.blueprints.util.tracer.Debug;
import com.sun.j2ee.blueprints.petstore.util.JNDINames;

import com.sun.j2ee.blueprints.petstore.control.event.EStoreEvent;
import com.sun.j2ee.blueprints.petstore.control.event.CartEvent;
import com.sun.j2ee.blueprints.petstore.control.event.AccountEvent;
import com.sun.j2ee.blueprints.petstore.control.event.OrderEvent;
import com.sun.j2ee.blueprints.petstore.control.event.LoginEvent;
import com.sun.j2ee.blueprints.petstore.control.event.LogoutEvent;

/**
 * This class uses the EStoreEvent type to deduce the list of
 * models that need to be updated because of this event.
 */
public class ModelUpdateManager     
                                     // start JBoss patch 
    implements java.io.Serializable 
                                     // end JBoss patch 

                                    {

    public ModelUpdateManager() {
    }

    /**
     * @return a list of names of models that could have changed due to this event.
     * The names chosen to refer to models is taken from JNDINames.
     * @see com.sun.j2ee.blueprints.petstore.util.JNDINames
     */
    public Collection getUpdatedModels(EStoreEvent ese)
        throws RemoteException {
        Debug.println("ModelUpdateManager: getUpdateModels");

        ArrayList modelList = new ArrayList();

        if (ese instanceof CartEvent) {
                Debug.println("ModelUpdateManager: CartEvent");
                modelList.add(JNDINames.CART_EJBHOME);
                Debug.println("ModelUpdateManager: CartEvent Over");
        } else if (ese instanceof AccountEvent) {
                Debug.println("ModelUpdateManager: AccountEvent");
                modelList.add(JNDINames.CUSTOMER_EJBHOME);
                modelList.add(JNDINames.PROFILEMGR_EJBHOME);
                Debug.println("ModelUpdateManager: AccountEvent over");
        } else if (ese instanceof OrderEvent) {
        // do not need this functionality right now, OrderBean does not
        // need to know of model change event.
        //String id = "#" + String.valueOf(((OrderEvent)ese).getRequestId());
        //modelList.add(JNDINames.ORDER_EJBHOME+id );
                Debug.println("ModelUpdateManager: OrderEvent");
                modelList.add(JNDINames.CUSTOMER_EJBHOME);
                Debug.println("ModelUpdateManager: OrderEvent : customer done");
                modelList.add(JNDINames.INVENTORY_EJBHOME);
                Debug.println("ModelUpdateManager: OrderEvent : inven done");
                modelList.add(JNDINames.CART_EJBHOME);
                Debug.println("ModelUpdateManager: OrderEvent completed");
        } else if (ese instanceof LoginEvent) {
                Debug.println("ModelUpdateManager: LoginEvent");
                modelList.add(JNDINames.CUSTOMER_EJBHOME);
                modelList.add(JNDINames.PROFILEMGR_EJBHOME);
                Debug.println("ModelUpdateManager: LoginEvent over");
        }
        return modelList;
    }
}
